/**
 * Program: AppletFrame.java
 * Comments: A frame to put applets so that they can be run as applications.
 * Taken from Cay Horstmann's example 10-12 in "Core Java".
 */

package WebFlow.ToolBar;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

public class AppletFrame extends JFrame implements AppletStub, AppletContext
{ 
    AppletFrame(Applet a, int x, int y) {
	this(a);
	setSize(x, y);

    }
    
    AppletFrame(Applet a, String title) {
	this(a);
	setTitle(title);
    }
    AppletFrame(Applet a) {
	addWindowListener(new WindowAdapter()
	    {  public void windowClosing(WindowEvent e)
		{  System.exit(0);
		}
	    } );
	Container contentPane = getContentPane();
	contentPane.add(a);
	a.setStub(this);
	a.init();
	pack();
	show();
	a.start();
    }
    
   // AppletStub methods
   public boolean isActive() { return true; }
   public URL getDocumentBase() { return null; }
   public URL getCodeBase() { return null; }
   public String getParameter(String name) { return ""; }
   public AppletContext getAppletContext() { return this; }
   public void appletResize(int width, int height) {}
   
   // AppletContext methods
   public AudioClip getAudioClip(URL url) { return null; }
   public Image getImage(URL url) { return null; }
   public Applet getApplet(String name) { return null; }
   public Enumeration getApplets() { return null; }
   public void showDocument(URL url) {}
   public void showDocument(URL url, String target) {}
   public void showStatus(String status) {}
}

