/**
 * Program: LocalTree.java
 * Comments: Creates a tree from the local file system.
 */

package WebFlow.ToolBar;

import javax.swing.tree.*;
import java.io.*;

public class LocalTree extends TreeFactory {

    public LocalTree() {;}

    //This overrides the abstract method of the parent.
    public String[] returnFiles(String dirName) {
	String[] fileList=null;
	try{
	    File thisDir=new File(dirName);
	    fileList=thisDir.list();
	}
	catch(Exception ex) {
	    System.err.println("Couldn't open the file.");
	    ex.printStackTrace();
	}
	return fileList;
    }        
        
    
    /**
     * Add the nodes to the tree.  If the node is a file, it will have
     * no children. There is a hackish way for checking for directories.
     * I will not construct the entire directory tree at the beginning. 
     * Instead, I will do this when I receive a tree expansion event.
     */
    public void addNodes(DefaultMutableTreeNode parent, DefaultTreeModel model,
			 String[] fileList, String parentDir){
	if(fileList.length>0) {
	    for(int i=0;i<fileList.length;i++){
		DefaultMutableTreeNode tmpNode=
		    new DefaultMutableTreeNode();
		if((new File(parentDir+fileList[i])).isDirectory()){
		    addNodes(tmpNode,model,new String[0],fileList[i]);
		}
		tmpNode.setUserObject(fileList[i]);
		model.insertNodeInto(tmpNode,parent,parent.getChildCount());
	    }
	}
	else {
	    DefaultMutableTreeNode tmpNode=new DefaultMutableTreeNode();
	    tmpNode.setUserObject("<Empty>");
	    model.insertNodeInto(tmpNode,parent,parent.getChildCount());
	}
	
    }
    
}


