/**
 * Program: RemoteTree.java
 * Comments: Creates a tree from the local file system.
 */

package WebFlow.ToolBar;

import javax.swing.tree.*;
import java.io.*;
import WebFlow.FB.*;
import WebFlow.RemoteFile.*;

public class RemoteTree extends TreeFactory {
    RemoteFile rf;
    FBServer fb;
    
    /**
     * Constructor is passed references to the modules created by the 
     * calling program.  For future expansion, may want constructors that
     * can create this objects within the program.
     */
    public RemoteTree(RemoteFile rf,FBServer fb) {
	this.rf=rf;
	this.fb=fb;
    }

    /**
     * This overrides the abstract method of the parent. 
     */ 
    public String[] returnFiles(String dirName) {
	String[] fileList=fb.getFileList(dirName);
	return fileList;
    }    

    /**
     * Add the nodes to the tree.  If the node is a file, it will have
     * no children. There is a hackish way for checking for directories.
     * I will not construct the entire directory tree at the beginning. 
     * Instead, I will do this when I receive a tree expansion event.
     */
    public void addNodes(DefaultMutableTreeNode parent, DefaultTreeModel model,
			 String[] fileList, String parentDir){
	if(fileList.length>0) {
	    for(int i=0;i<fileList.length;i++){
		DefaultMutableTreeNode tmpNode=
		    new DefaultMutableTreeNode();
		if(fb.checkForDirectory(parentDir+fileList[i])) {
		    addNodes(tmpNode,model,new String[0],fileList[i]);
		}
		tmpNode.setUserObject(fileList[i]);
		model.insertNodeInto(tmpNode,parent,parent.getChildCount());
	    }
	}
	else {
	    DefaultMutableTreeNode tmpNode=new DefaultMutableTreeNode();
	    tmpNode.setUserObject("<Empty>");
	    model.insertNodeInto(tmpNode,parent,parent.getChildCount());
	}
	
    }
    
}




