/**
 * Define the command for an item in the "Submit Job" menu.
 */

package WebFlow.ToolBar;
import WebFlow.submitJob.*;
import WebFlow.SerialHash.*;
import java.util.*;
import java.io.*;
import java.net.*;

public class SJCmd implements Command {
    
    String probName,probVal,dir;
    submitJob sj=null;
    SerialHash sh=null;
    String machine,userName,command;
    Hashtable paramHash;
    
    public SJCmd(String probName,String probVal,submitJob sj,SerialHash sh,
		 String dir) {
	this.probName=probName;
	this.probVal=probVal;
	this.sj=sj;
	this.sh=sh;
	this.dir=dir;
    }
    public void Execute(){
	sh.openHash(dir);
	sh.deleteEntry(probName);
	sh.closeHash();
	
	//Take the probVal string and break it up into its components.
	//I'm assuming the order machine+userName+command.
	StringTokenizer st=new StringTokenizer(probVal,"+");
	machine=st.nextToken();
	userName=st.nextToken();
	command=st.nextToken();
	String jobID=sj.execRemoteCommand(machine,userName,command,"rsh");
	System.out.println("jobid is "+jobID);
	
	//Set up the hashtable of parameters and call the 
	//servlet.
	paramHash=new Hashtable();
	paramHash.put("event","update");
	paramHash.put("append",jobID);
	paramHash.put("job",probName);
	callServlet12("http://dev-spt01:8080/GOW/servlet/"
		      +"WebFlow.Servlets.MonitorJobServ");
    }

    /**------------------------------------------------------------
     * Call the servlet that reads the hashtable file.
     * Output is returned line by line and sent to 
     * the method displayResponse() for displaying in the text area.
     * 
     * The following version apparently does not work with 
     * Netscape.
     *------------------------------------------------------------*/
    private void callServlet12(String servletURL){
	//Based on example 3.8 from Cay Horstmann's "Core Java 2".
	//	StringBuffer response=new StringBuffer();

	java.net.URL url=null;
	java.net.URLConnection conn=null;
	BufferedReader in=null;

	try{
	    url=new java.net.URL(servletURL);
	    conn=url.openConnection();
	    conn.setDoOutput(true);
	    conn.setDoInput(true);
	    conn.setDefaultUseCaches(false);
	    conn.setUseCaches(false);
	    
  	    PrintWriter out=
  		new PrintWriter(conn.getOutputStream());

	    //The following are parameters passed to the servlet.
	    Enumeration en=paramHash.keys();
	    System.out.println("Size is "+paramHash.size());
	    while(en.hasMoreElements()) {
		String name=(String)en.nextElement();
		String value=(String)paramHash.get(name);
		String ch;
		if(en.hasMoreElements()) ch="&";
		else ch="";
		System.out.println(name+"="+URLEncoder.encode(value)+ch);
		out.print(name+"="+URLEncoder.encode(value)+ch);

	    }
	    //Clear out all entries.
	    paramHash.clear();
	    out.close();
	}
	catch (Exception e){e.printStackTrace();}

	try {
	    in=new BufferedReader(new 
		    InputStreamReader(conn.getInputStream()));

	    //Put contents of jobHash into a vector.
	    String line;
	    Vector jobVector=new Vector();
	    while((line=in.readLine()) !=null){
		//Do nothing.
		jobVector.addElement(line);
	    }
	    in.close();
	    
	}
	catch(FileNotFoundException ex) {
	    InputStream err=((HttpURLConnection)conn).getErrorStream();
	    in=new BufferedReader(new InputStreamReader(err));
	}
	catch(Exception e) {e.printStackTrace();}

    }

}

